const min_len = 6;
const max_len = 20;

$(document).ready(function(){
    for(let x = min_len; x <= max_len; x++){
        $("#passlength").append(new Option(x,x));
    }
});


const mix_set = {
    "lowercase": "abcdefghijklmnopqrstuvwxyz",
    "uppercase": "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
    "numbers": "0123456789",
    "symbols": "~!@#$%^&*()-_=+[]{};:,.<>?"
};


function shuffleWord(word){
    const chars = word.split("");
    for(let i = chars.length - 1; i > 0; i--){
        const j = Math.floor(Math.random() * (i + 1));
        [chars[i], chars[j]] = [chars[j], chars[i]];
    }
    return chars.join("");
}


$("#password-container").on("click","#genpass",function(e){
    e.preventDefault();
    let passmix = []; passmix[0] = "lowercase";
    let maxcnt = 0;
    let limit = 0;
    let mix_tmp = "";
    let passlen = $("#passlength option:selected").val();
    
    $("input[name='passmix']:checked").each(function(){
        passmix.push($(this).val());
    });
    
    for(let i = 0; i < passmix.length; i++){
        maxcnt = passlen - (passmix.length - 1) - (mix_tmp.length - i);

        if(i == (passmix.length - 1)){
            limit = maxcnt;
        } else {
            limit = Math.floor((Math.random()*maxcnt)+1)
        }
        
        for(let t = 0; t < limit; t++){
            mix_tmp += mix_set[passmix[i]].charAt(Math.floor(Math.random() * mix_set[passmix[i]].length));
        }
    }

    mix_tmp = shuffleWord(mix_tmp);
    $("#password-display").html(mix_tmp);
});